/*
  Примеры для книги Белова Александра
  Программа 5.2.    Глава 5
  Переключаемый светодиод 
  (с использованием переменной для хранения состояния кнопки)

 Переключение светодиода (LED), подключенного к цифровому контакту 8, 
 при каждом нажатии на кнопку, подключенную к контакту 2 светодиод переключается
 при первом нажатии загорается, при втором гаснет, при следующем - загорается и так далее.

 Схема:
 * Последовательное соединение светодиода и резистора 270 Ом подключается между выводом 8 и контактом +5 В
 * Кнопка подключается между контактом 2 и общим  проводом
 */

// Постоянные константы. В данной программе
// константы определяют номера используемых контактов:
const int buttonPin = 2;     // номер контакта для подключения кнопки
const int ledPin = 8;        // номер контакта для подключения светодиода

// изменяемые переменные:
int LEDstate = HIHG;   // переменная для хранения состояния светодиода

void setup() {
  // инициализируем контакт светодиода на вывод:
  pinMode(ledPin, OUTPUT);
  // инициализируем контакт кнопки на ввод:
  pinMode(buttonPin, INPUT_PULLUP);
  digitalWrite(ledPin, ledState);
}

void loop() {
  // Ожидание нажатия кнопки:
  while (digitalRead(buttonPin)==HIGH) {};
  // Переключение светодиода:
  ledState = !ledstate;
  digitalWrite(ledPin, ledState);
   // ожидание отпускания кнопки:
  while (digitalRead(buttonPin)==LOW) {};
}
