/*
  Примеры для книги Белова Александра
  Программа 5.3.    Глава 5
  Простейшая программа с использованием прерывания

 Включение и выключение светодиода (LED), подключенного к цифровому контакту 8, 
 при нажатии на кнопку, подключенную к контакту 2.

 Схема:
 * Последовательное соединение светодиода и резистора 270 Ом подключается между выводом 8 и контактом +5 В
 * Кнопка подключается между контактом 2 и общим  проводом
 */

// Определение констант:
const int buttonPin = 2;     // номер вывода с кнопкой
const int ledPin =  8;       // номер вывода со светодиодом

volatile int ledState = HIGH;   // переменная для хранения состояния светодиода

void setup() 
{
  // настроить вывод светодиода на выход:
  pinMode(ledPin, OUTPUT);
  // настроить вывод кнопки на вход:
  pinMode(buttonPin, INPUT_PULLUP);
  digitalWrite(ledPin, ledState);
  // прикрепить прерывание к вектору ISR
  attachInterrupt(digitalPinToInterrupt(buttonPin), pinISR, FALLING);
}

// Основной цикл программы
void loop() 
{
  // Основной цикл остается свободным!
  // Тут можно размещать основную программу
  // на фоне которой будет выполняться переключение светодиода в фоновом режиме
}

// Обработчик прерывания
void pinISR() 
{
  ledState = !ledState;
  digitalWrite(ledPin, ledState);
}


