/*
  Примеры для книги Белова Александра
  Программа 6.1.   Глава 6
  Программный антидребезг
  
 Переключение светодиода (LED), подключенного к цифровому контакту 8, 
 при каждом нажатии на кнопку, подключенную к контакту 2 светодиод переключается (горит/не горит).
 с использованием программного антидребезга

 Схема:
 * Последовательное соединение светодиода и резистора 270 Ом подключается между выводом 8 и контактом +5 В
 * Кнопка подключается между контактом 2 и общим  проводом
 */

// Постоянные константы. В данной программе
// константы определяют номера используемых контактов:
const int buttonPin = 2;     // номер контакта для подключения кнопки
const int ledPin = 8;        // номер контакта для подключения светодиода
const int DelayTime = 20;    // Время задержки антидребезга

void setup() {
  // инициализируем контакт светодиода на вывод:
  pinMode(ledPin, OUTPUT);
  // инициализируем контакт кнопки на ввод:
  pinMode(buttonPin, INPUT_PULLUP);
}

void loop() {
  // Ожидание нажатия кнопки:
  while (digitalRead(buttonPin)==HIGH) {};
  // Задержка после нажатия кнопки
  delay (DelayTime);
  // Переключение светодиода:
  digitalWrite(ledPin, !digitalRead(ledPin)); 
  // ожидание отпускания кнопки:
  while (digitalRead(buttonPin)==LOW) {};
  // Задержка после отпускания кнопки
  delay (DelayTime);
}
