/*
 Программы для книги Белова Александра
 Программа 9.2.   Глава 9
 Бегущие огни
 
 Схема:
 * Восемь цепочек из последовательного соединенного резистора 270 Ом и светодиода
 * Подключаются между пинами от 2 до 9 и цепью +5 В
 */
const int buttonPin = 13;  // Номер контакта для подключения кнопки
const int LoopTime = 200;   // Значение времени задержки шага бегущего огня

int loopStart = 2;   // Начало цикла бега
int loopStop = 10;   // Конец цикла бега
int loopStep = 1;    // Шаг цикла бега

int thisPin;         // Текущий пин
unsigned long lastTime;

void setup() {
  // Цикл инициализации пинов для подключения светодиодов:
  for (int thisPin = 2; thisPin < 10; thisPin++) {
    pinMode(thisPin, OUTPUT);
    digitalWrite(thisPin, HIGH);
  }
  // Инициализация пина подключения кнопки:
  pinMode(buttonPin, INPUT);
  lastTime = 0;
  thisPin = loopStart;
}

void loop() {
  if (lastTime == 0) {
    digitalWrite(thisPin, LOW);
    lastTime = millis();
  }

  // Тут можно выполнять другие действия
  // ............
  // ............

    

  if (millis() - lastTime > LoopTime) {
    digitalWrite(thisPin, HIGH);
    thisPin += loopStep;
    if (thisPin == loopStop) {
      if (digitalRead(buttonPin)==HIGH) { loopStart = 2; loopStop = 10; loopStep = 1; }
      else { loopStart = 9; loopStop = 1; loopStep = -1; }
      thisPin = loopStart;
    }
    lastTime = 0;
  }
}  


