/*
 Программы для книги Белова Александра
 Программа 10.1.    Глава 10
 Бегущие огни. использование прерываний по таймеру
 
 Схема:
 * Восемь цепочек из последовательного соединенного резистора 270 Ом и светодиода
 * Подключаются между пинами от 2 до 9 и цепью +5 В
 */

#include <MsTimer2.h>

const int buttonPin = 13;   // номер контакта для подключения кнопки
const int LoopTime = 200;   // Значение времени задержки шага бегущего огня
const int loopStart = 2;    // Начало цикла бега
const int loopStop  = 9;    // Конец цикла бега

volatile int thisPin; // Текущий разряд светодиодов

void setup() {
  // Цикл инициализации пинов для подключения светодиодов:
  for (int thisPin = 2; thisPin < 10; thisPin++) {
    pinMode(thisPin, OUTPUT);
    digitalWrite(thisPin, HIGH);
  }
  pinMode(buttonPin, INPUT); // Инициализация пина подключения кнопки
  thisPin = loopStart;   // Присвоение начального значения указателю светодиода
  // Инициализация таймера и привязка к нему прерывания
  MsTimer2::set(LoopTime, timerInterupt);   // задаем период прерывания по таймеру LoopTime 
  MsTimer2::start();                     // разрешаем прерывание по таймеру
}

void loop() {
  // Основной цикл остается свободным
  // Сюда вы можете поместить основную программу
  // на фоне которой будет выполняться программа бегущих огней
}

// обработчик прерывания 
void  timerInterupt() {
  digitalWrite(thisPin, HIGH);   // Выключение текущего светодиода
  if (digitalRead(buttonPin)==HIGH) {
    // Делаем один шаг бегущего огня в прямом направлении:
    thisPin++;
    if (thisPin > loopStop) thisPin = loopStart;
  }
  else {
    // Делаем один шаг бегущего огня в обратном направлении:
    thisPin--;
    if (thisPin < loopStart) thisPin = loopStop;
  }
  digitalWrite(thisPin, LOW);    // Включение следующего светодиода
}


