/*
  Примеры для книги Белова Александра
  Программа 11.1.    Глава 11
  Сигнализатор "десять нот"

При нажати на любую из десяти кнопок устройство вырабатывает звуковой сигнал
для каждой ккнопки свой звук

 Схема:
 * Десять кнопок подключаются к пинам с 0 по 9,
 * звукоизлучатель через конденсатор 4,7 мкф подключается между пином 12 и общим проводом
 */

// Постоянные константы:
const int SoundPin = 12;     // номер контакта для подключения звукоизлучателя

//частоты нот
const int tabFreq[10] = { 1046, 987, 932, 880, 831, 784, 740, 698, 659, 622 };

// Переменные:
int ButtonPin;  // Номер контакта текущей кнгпки

void setup() {
  // инициализируем пин звука на вывод:
  pinMode(SoundPin, OUTPUT);
  // инициализируем пины кнопок на ввод:
  for (ButtonPin=0; ButtonPin<=9; ButtonPin++) {
    pinMode(ButtonPin, INPUT_PULLUP);
  }
}

void loop() {
  // Сканирование кнопок и воспроизведение звука:
  boolean btFree = true;  // Флаг "все кнопки отпущены"
  for (ButtonPin=0; ButtonPin<=9; ButtonPin++) {
    if (digitalRead(ButtonPin)==LOW) {
      tone (SoundPin, tabFreq[ButtonPin]);
      btFree = false;
      break;
    }
  }
  if (btFree) noTone(SoundPin);
}
